#
# Read data; set defaults
# 
  z <- c(4.37, 5.23,   4.38, 5.02,
         4.56, 5.74,   4.42, 4.66,
         4.26, 4.93,   4.29, 4.66,
         4.56, 5.74,   4.38, 4.90,
         4.30, 5.19,   4.22, 4.39,
         4.46, 5.46,   3.48, 6.05,
         3.84, 4.65,   4.38, 4.42,
         4.57, 5.27,   4.56, 5.10,
         4.26, 5.57,   4.45, 5.22,
         4.37, 5.12,   3.49, 6.29,
         3.49, 5.73,   4.23, 4.34,
         4.43, 5.45,   4.62, 5.62,
         4.48, 5.42,   4.53, 5.10,
         4.01, 4.05,   4.45, 5.22,
         4.29, 4.26,   4.53, 5.18,
         4.42, 4.58,   4.43, 5.57,
         4.23, 3.94,   4.38, 4.62,
         4.42, 4.18,   4.45, 5.06,
         4.23, 4.18,   4.50, 5.34,
         3.49, 5.89,   4.45, 5.34,
         4.29, 4.38,   4.55, 5.54,
         4.29, 4.22,   4.45, 4.98,
         4.42, 4.42,   4.42, 4.50,
         4.49, 4.85)
 cx      <- matrix(z, ncol=2, byrow=TRUE)
 n       <- nrow(cx); np <- ncol(cx)
 dst0    <- vector("numeric",n)
 dfvals()
#-----------------------------------------------------------------------
# Classical covariance
#
  t0     <- apply(cx, 2, mean)
  xmb    <- sweep(cx, 2, t0)
  cv0    <- crossprod(xmb)/n
# Mahalanobis distances
  cvm1   <- solve(cv0)
  for (i in 1:n) {
      z  <- xmb[i,]; dst0[i] <- sqrt(z %*% cvm1 %*% t(t(z)))}

#=======================================================================
# M-estimate of covariance
#
   zc    <- cicloc()
   za    <- cia2b2(nvar=np)
   a2    <- za$a2; b2 <- za$b2
   zd    <- cibeat(a2, b2, np)
   cw    <- zc$c;  dv <- zd$d
   dfcomn(iucv=1, a2=a2, b2=b2, bt=dv, cw=cw)
   zf    <- cifact(a2,b2,np)
   z     <- cimedv(cx)
   ai    <- z$a; ti <- z$t;  fc <- zf$fc
#-----------------------------------------------------------------------
# With prescription F0
   zd    <- cyfalg(cx,ai,ti)
   zc    <- cfrcov(zd$a,np,fc)
   cv1   <- zc$cov; t1 <- zd$t; dst1 <- zd$dist; nt1 <- zd$nit
#-----------------------------------------------------------------------
# With prescription NH
   zd    <- cynalg(cx,ai,ti)
   zc    <- cfrcov(zd$a,np,fc)
   cv2   <- zc$cov; t2 <- zd$t; dst2 <- zd$dist; nt2 <- zd$nit
#-----------------------------------------------------------------------
# With prescription CG
   zd    <- cygalg(cx,ai,ti)
   zc    <- cfrcov(zd$a,np,fc)
   cv3   <- zc$cov; t3 <- zd$t; dst3 <- zd$dist; nt3 <- zd$nit
#.......................................................................
   write("cv0[2x2] // t0[1:2] // dst0","cvrslt.r")
   write(cv0,"cvrslt.r",2,T); write(t0,"cvrslt.r",2,T)
   write(dst0,"cvrslt.r",4,T)
   write("cv1[1:3] // t1[1:2] // dst1","cvrslt.r",1,T)
   for (i in 1:2) {
    j <- i*(i-1)/2 +1; k <- j+i-1; write(cv1[j:k],"cvrslt.r",i,T)} 
   write(t1,"cvrslt.r",2,T); write(dst1,"cvrslt.r",4,T)
   write("cv2[1:3] // t2[1:2] // dst2","cvrslt.r",1,T)
      for (i in 1:2) {
    j <- i*(i-1)/2 +1; k <- j+i-1; write(cv2[j:k],"cvrslt.r",2,T)} 
   write(t2,"cvrslt.r",2,T); write(dst2,"cvrslt.r",4,T)
   write("cv3[1:3] // t3[1:2] // dst3","cvrslt.r",1,T)
      for (i in 1:2) {
    j <- i*(i-1)/2 +1; k <- j+i-1; write(cv3[j:k],"cvrslt.r",2,T)}
   write(t3,"cvrslt.r",2,T); write(dst3,"cvrslt.r",4,T)
