#
# Read data; load defaults
# 
  z <- c(80, 27, 89, 42, 
         80, 27, 88, 37, 
         75, 25, 90, 37, 
         62, 24, 87, 28,
         62, 22, 87, 18, 
         62, 23, 87, 18, 
         62, 24, 93, 19, 
         62, 24, 93, 20,
         58, 23, 87, 15, 
         58, 18, 80, 14, 
         58, 18, 89, 14, 
         58, 17, 88, 13,
         58, 18, 82, 11, 
         58, 19, 93, 12, 
         50, 18, 89,  8, 
         50, 18, 86,  7,
         50, 19, 72,  8, 
         50, 19, 79,  8, 
         50, 20, 80,  9, 
         56, 20, 82, 15,
         70, 20, 91, 15)
 x       <- matrix(z, ncol=4, byrow=TRUE)
 y       <- x[,4]; x[,4] <- 1
 n       <- length(y); np <- ncol(x)
 nq      <- np+1
 dfvals()
#
# Least median of squares
#
  zr     <- hylmse(x,y, nq, ik=1, iopt=3, intch=1)
  theta1 <- zr$theta; xmin1 <- zr$xmin
  zr     <- hylmse(x,y, nq, ik=2, iopt=3, intch=1)
  theta2 <- zr$theta; xmin2 <- zr$xmin
  zr     <- hylmse(x,y, nq, ik=1, iopt=1, intch=1)
  theta3 <- zr$theta; xmin3 <- zr$xmin

#
# Least trimmed squares
#
  zr     <- hyltse(x,y, nq, ik=1, iopt=3, intch=1)
  theta4 <- zr$theta; xmin4 <- zr$smin
  zr     <- hyltse(x,y, nq, ik=2, iopt=3, intch=1)
  theta5 <- zr$theta; xmin5 <- zr$smin
  zr     <- hyltse(x,y, nq, ik=1, iopt=1, intch=1)
  theta6 <- zr$theta; xmin6 <- zr$smin

#
# S-estimate
#
  z      <- dfrpar(x,'S')
  z      <- ribetu(y) 
  zr     <- hysest(x,y, nq, iopt=3, intch=1)
  theta7 <- zr$theta[1:np]; xmin7 <- zr$smin
  zr     <- hysest(x,y, nq, iopt=1, intch=1)
  theta8 <- zr$theta[1:np]; xmin8 <- zr$smin
#.......................................................................
  write("Results","hbrslt.r")
  write("theta1 // xmin1","hbrslt.r",1,T)
  write(theta1,"hbrslt.r",4,T); write(xmin1,"hbrslt.r",1,T)
  write("theta2// xmin2","hbrslt.r",1,T)
  write(theta2,"hbrslt.r",4,T); write(xmin2,"hbrslt.r",1,T)
  write("theta3 // xmin3","hbrslt.r",1,T)
  write(theta3,"hbrslt.r",4,T); write(xmin3,"hbrslt.r",1,T)
  write("theta4 // xmin4","hbrslt.r",1,T)
  write(theta4,"hbrslt.r",4,T); write(xmin4,"hbrslt.r",1,T)
  write("theta5 // xmin5","hbrslt.r",1,T)
  write(theta5,"hbrslt.r",4,T); write(xmin5,"hbrslt.r",1,T)
  write("theta6 // xmin6","hbrslt.r",1,T)
  write(theta6,"hbrslt.r",4,T); write(xmin6,"hbrslt.r",1,T)
  write("theta7 // xmin7","hbrslt.r",1,T)
  write(theta7,"hbrslt.r",4,T); write(xmin7,"hbrslt.r",1,T)
  write("theta8 // xmin8","hbrslt.r",1,T)
  write(theta8,"hbrslt.r",4,T); write(xmin8,"hbrslt.r",1,T)
#***************************************************************************
