 bindec <- function(np,ind,cpc,cpr) {
 n      <- length(ind)
 ccar   <- matrix("-",ncol=np, nrow=n)
 for (i in 1:n) {
    j   <- 0
    num <- abs(ind[i])
    while (num != 0 & j < np) {
     j   <- j+1
     if (num %% 2 == 1) ccar[i,j] <- "X"
     num <- num %/% 2}}
   cbind(cpc,cpr,ind,ccar)
 }
#-----------------------------------------------------------------------
# Read data
# 
 z <- c(-1, -2,  0,   35,         1,  0, -3,   20,
        -1, -2,  0,   30,         1,  0, -3,   39,
        -1, -2,  0,   24,         1,  0, -3,   16,
        -1, -2,  0,   37,         1,  0, -3,   27,
        -1, -2,  0,   28,         1,  0, -3,  -12,
        -1, -2,  0,   73,         1,  0, -3,    2,
        -1, -2,  0,   31,         1,  0, -3,   31,
        -1, -2,  0,   21,         1,  0, -1,   26,
        -1, -2,  0,   -5,         1,  0, -1,   60,
        -1,  0,  0,   62,         1,  0, -1,   48,
        -1,  0,  0,   67,         1,  0, -1,   -8,
        -1,  0,  0,   95,         1,  0, -1,   46,
        -1,  0,  0,   62,         1,  0, -1,   77,
        -1,  0,  0,   54,         1,  0,  1,   57,
        -1,  0,  0,   56,         1,  0,  1,   89,
        -1,  0,  0,   48,         1,  0,  1,  103,
        -1,  0,  0,   70,         1,  0,  1,  129,
        -1,  0,  0,   94,         1,  0,  1,  139,
        -1,  0,  0,   42,         1,  0,  1,  128,
        -1,  2,  0,  116,         1,  0,  1,   89,
        -1,  2,  0,  105,         1,  0,  1,   86,
        -1,  2,  0,   91,         1,  0,  3,  140,
        -1,  2,  0,   94,         1,  0,  3,  133,
        -1,  2,  0,  130,         1,  0,  3,  142,
        -1,  2,  0,   79,         1,  0,  3,  118,
        -1,  2,  0,  120,         1,  0,  3,  137,
        -1,  2,  0,  124,         1,  0,  3,   84,
        -1,  2,  0,   -8,         1,  0,  3,  101)
  xx    <- matrix(z,ncol=4, byrow=T)
  dimnames(xx) <- list(NULL,c("z2","xS","xT","y"))
  z2    <- xx[,"z2"]; xS <- xx[,"xS"]; xT <- xx[,"xT"]
  x     <- cbind(1, z2, xS+xT, xS-xT, xS^2+xT^2, xS^2-xT^2, xT^3)
  y     <- xx[,"y"]
  wgt   <- vector("numeric",length(y))
  n     <- 56; np <- 7
 dfvals()
# Compute classical sigma and the t-statistics
 dfrpar(x,"ols",-1,-1)
 z     <- mirtsr(x,y,.dFv$ite)
 sigmc <- z$sigma; tstac <- z$t
 
# Compute robust sigma and the t-statistics
 dfrpar(x,"huber",-1,-1)
 z     <- mirtsr(x,y,.dFv$ite)
 sigmr <- z$sigma; tstar <- z$t
#
# All possible regressions including  the constant and linear terms
#
 vp     <- rep(-0.5, length=np)
 vp[1]  <- 3; vp[3]  <- 2; vp[4]  <- 1
 za     <- mfragr(x, y, vp, nc=18, .dFv$ite, sigmac=sigmc, sigmar=sigmr)
#
# Priorites by means of t-directed search
#
 zt     <- mfragr(x, y, tstar, nc=7, .dFv$ite, sigmac=sigmc, sigmar=sigmr)
#.......................................................................
 write(c("Results","Regressions on subset of variables"),"mxrslt.r")
 write("sigmc, sigmr // tstar[1:7]","mxrslt.r",1,T)
 write(c(sigmc,sigmr),"mxrslt.r",2,T); write(tstar,"mxrslt.r",4,T)
 write("C_p, C_{p,alpha}, ipr, binary(ipr)","mxrslt.r",1,T)
 write(t(bindec(np,za$ipr,za$cpc,za$cpr)),"mxrslt.r",10,T) 
 write("t-directed search","mxrslt.r",1,T)
 write(t(bindec(np,zt$ipr,zt$cpc,zt$cpr)),"mxrslt.r",10,T) 
#=======================================================================
#
# Read data; set defaults
# 
  z <- c(4.37, 5.23,   4.48, 5.42,   4.38, 5.02,   4.53, 5.10,
         4.56, 5.74,   4.01, 4.05,   4.42, 4.66,   4.45, 5.22,
         4.26, 4.93,   4.29, 4.26,   4.29, 4.66,   4.53, 5.18,
         4.56, 5.74,   4.42, 4.58,   4.38, 4.90,   4.43, 5.57,
         4.30, 5.19,   4.23, 3.94,   4.22, 4.39,   4.38, 4.62,
         4.46, 5.46,   4.42, 4.18,   3.48, 6.05,   4.45, 5.06,
         3.84, 4.65,   4.23, 4.18,   4.38, 4.42,   4.50, 5.34,
         4.57, 5.27,   3.49, 5.89,   4.56, 5.10,   4.45, 5.34,
         4.26, 5.57,   4.29, 4.38,   4.45, 5.22,   4.55, 5.54,
         4.37, 5.12,   4.29, 4.22,   3.49, 6.29,   4.45, 4.98,
         3.49, 5.73,   4.42, 4.42,   4.23, 4.34,   4.42, 4.50,
         4.43, 5.45,   4.49, 4.85,   4.62, 5.62)
 cx      <- matrix(z, ncol=2, byrow=TRUE)
 n       <- nrow(cx); np <- ncol(cx)
 y       <- vector("numeric",length=n)
#
# Minimum Volume Ellipsoid covariances 
#
 z       <- mymvlm(cx,y,ilms=0,iopt=3,iseed=5321)
 dst     <- z$d;  cv <- z$cov; xvol <- z$xvol
#.......................................................................
 write("Minimum Volume Ellipsoid covariances","mxrslt.r",1,T)
 write(cv,"mxrslt.r",3,T)
 write("Objective function value","mxrslt.r",1,T)
 write(xvol,"mxrslt.r",1,T)
 write("distance","mxrslt.r",1,T); write(dst,"mxrslt.r",4,T)
#=======================================================================  
#
# Read data; load defaults
# 
  z <- c(80, 27, 89, 42, 
         80, 27, 88, 37, 
         75, 25, 90, 37, 
         62, 24, 87, 28,
         62, 22, 87, 18, 
         62, 23, 87, 18, 
         62, 24, 93, 19, 
         62, 24, 93, 20,
         58, 23, 87, 15, 
         58, 18, 80, 14, 
         58, 18, 89, 14, 
         58, 17, 88, 13,
         58, 18, 82, 11, 
         58, 19, 93, 12, 
         50, 18, 89,  8, 
         50, 18, 86,  7,
         50, 19, 72,  8, 
         50, 19, 79,  8, 
         50, 20, 80,  9, 
         56, 20, 82, 15,
         70, 20, 91, 15)
 x       <- matrix(z, ncol=4, byrow=TRUE)
 y       <- x[,4]; x[,4] <- 1
 n       <- length(y); np <- ncol(x)
 nq      <- np+1
 dfvals()
#
# High breakdown point & high efficiency regression
#
 dfrpar(x,"S",-1,-1)
 z <- myhbhe(x, y, iseed=5431)
#.......................................................................
 write("High breakdown point & high efficiency regression","mxrslt.r",1,T)
 write("theta0","mxrslt.r",1,T); write(z$theta0,"mxrslt.r",4,T)
 write("sigma0","mxrslt.r",1,T); write(z$sigm0,"mxrslt.r",1,T)
 write("theta1","mxrslt.r",1,T); write(z$theta1,"mxrslt.r",4,T)
 write("sigma, tbias","mxrslt.r",1,T)
 write(c(z$sigm1,z$tbias),"mxrslt.r",2,T)
